RUNS_HUMAN_VERSION	equ	3
	.cpu 68000
	.include	doscall.mac
	.include	iocscall.mac

	.even
	.text

	.even
	.globl	_pcmout
_pcmout
	move.l	d3,-(sp)
	move.l	12(sp),d0	*filename (full path)
	suba.l	a1,a1		*buftop=NULL
	move.w	a1,-(sp)	*read mode
	move.l	d0,-(sp)	*filename
	DOS	_OPEN
	move.l	d0,d2		*filehandle
	addq.w	#6,sp
	bmi	rtn

	move.w	#2,-(sp)	*from fileend
	move.l	a1,-(sp)	*offset 0
	move.w	d2,-(sp)	*filehandle
	DOS	_SEEK
	movea.l	d0,a2		*filesize
	moveq.l	#-1,d1
	moveq.l	#0,d3
	move.w	d1,d3		*65535
	subq.w	#1,d3		*65534
	add.l	d0,d3		*filesize+65534
	divu	d1,d3
	moveq.l	#0,d1
	move.w	d3,d1		*tblnum
	move.l	d1,d3
	move.l	d1,d0
	add.l	d1,d1
	add.l	d0,d1
	add.l	d1,d1		*sizeof(arraychain)*tblnum
	pea	(a2,d1.l)	*filesize+tblsize
	DOS	_MALLOC
	lea.l	12(sp),sp
	tst.l	d0
	bgt	bufOK
	move.w	d2,-(sp)	*filehandle
	DOS	_CLOSE
	addq.w	#2,sp
	bra	rtn
bufOK:
	move.w	a1,-(sp)	*from filetop
	move.l	a1,-(sp)	*offset
	movea.l	d0,a1		*buftop
	move.w	d2,-(sp)	*filehandle
	DOS	_SEEK

	move.l	a2,-(sp)	*filesize
	add.l	a1,d1
	move.l	d1,-(sp)	*datatop
	move.w	d2,-(sp)	*filehandle
	DOS	_READ
	move.l	d0,d2
	DOS	_CLOSE
	lea.l	18(sp),sp
	cmp.l	a2,d2		*file all read?
	beq	makearray
	move.l	a1,-(sp)	*buftop
	DOS	_MFREE
	addq.w	#4,sp
	suba.l	a1,a1		*NULL return
	bra	rtn

makearray:
	move.l	8(sp),a0	*pcmdata
	move.l	d3,(a0)+	*tblsize
	move.l	a1,(a0)		*adrs

	move.l	a2,d2		*filesize
	movea.l	a1,a0		*buftop
	move.l	d1,d0		*datatop
	move.l	#65535,d1
	bra	loop_ent
loop:
	move.l	d0,(a0)+
	move.w	d1,(a0)+
	add.l	d1,d0
	sub.l	d1,d2
loop_ent:
	cmp.l	d1,d2
	bgt	loop
	move.l	d0,(a0)+
	move.w	d2,(a0)

	move.l	d3,d2		*tblnum
	move.w	#$0403,d1
	IOCS	_ADPCMAOT
rtn:
	move.l	a1,d0
	move.l	(sp)+,d3
	rts

	.even
	.globl	_pcmstop
_pcmstop:
	suba.l	a1,a1
	IOCS	_B_SUPER
	move.l	d0,a1
	movea.l	$0088.w,a0
	subq.w	#8,a0
	move.l	(a0),d1
	IOCS	_B_SUPER

	cmp.l	#'PCM8',d1
	beq	pcm8
	cmp.l	#'PCM4',d1
	beq	pcm8

	moveq.l	#0,d1
	IOCS	_ADPCMMOD
	rts

pcm8:
	move.w	#$101,d0
	trap	#2
	move.w	#$100,d0
	trap	#2
	rts

	.even
	.end
