typedef struct {
	char	*name;
	int	(*func)( TBOX *tb );
} COMMAND;


int	adpcmout( TBOX *tb );
int	adpcmstop( TBOX *tb );
int	bgmplay( TBOX *tb );
int	bgmstop( TBOX *tb );
int	echo( TBOX *tb );
int	gclr( TBOX *tb );
int	gload( TBOX *tb );
int	gotolabel( TBOX *tb );
int	ifthen( TBOX *tb );
int	setexpr( TBOX *tb );
int	select( TBOX *tb );
int	nsnexit( TBOX *tb );
int	gtone( TBOX *tb );
int	datasave( TBOX *tb );

COMMAND	comtbl[]= {
	{ "@", setexpr },
	{ "ADPCMOUT", adpcmout },
	{ "ADPCMSTOP", adpcmstop },
	{ "BGMPLAY", bgmplay },
	{ "BGMSTOP", bgmstop },
	{ "DATASAVE", datasave },
	{ "ECHO", echo },
	{ "EXIT", nsnexit },
	{ "GCLR", gclr },
	{ "GLOAD", gload },
	{ "GOTO", gotolabel },
	{ "GTONE", gtone },
	{ "IF", ifthen },
	{ "SELECT", select },
	{ NULL, NULL }
};
