/*	Copyright 1992 H.Ogasawara (COR.)	*/
/*	modified 1998 by Shinichi Honma	*/

#include	<corlib.h>
#include	<dbslib.h>
#include	<sys_doslib.h>
#include	"PICSLICE.H"
#include	"nsn.h"
#include	"graph.h"


int	LoadJPEG( LAYER *lay, int mode )
{
	unsigned short	*gp;
	char	format[]= "JPEG";
	char	*name;

	name= getfullname( lay->name );

	if( mode ){
		return jpeg_info( name, &(lay->h), &(lay->v) );
	}

	lay->buf= NULL;
	if( !jel && !(jel= DBOpen( "jel" ) ) ){
		psierr( format, -1 );
		return FALSE;
	}

	do {
		gp= jel( name, &(lay->h), &(lay->v) );
		if( gp )	break;
	} while( layfree() );

	if( !gp ){
		psierr( format, PICSLICE_EREAD );
		return FALSE;
	}else {
		lay->buf= gp;
	}
	return TRUE;
}
