#include	<corlib.h>
#include	<HS_wlib.h>
#include	<string.h>
#include	<iocslib.h>
#include	"nsn.h"
#include	"sub.h"

#define		Ctrl(a)	((a)&0x1f)

typedef struct {
	int	max;					/* TuEBhE\Gg */
	int	target;					/* TuEBhEJ[\ʒu */
	unsigned char	*label[8];	/* ʖ */
	unsigned char	name[8][42];/* I */
	unsigned char	title[42];	/* TuEBhE^Cg */
} SUBINF;

static void	cursormove( WindowID, int, SUBINF* );
static int	WinKey( WindowID, EventInfo*, SUBINF* );
static int	SExec( WindowID, EventInfo* );


static void	cursormove( WindowID wp, int i, SUBINF *inf )
{
	DrawBuf	dbuf[2], *dp= dbuf;

	DrawSetSymbol( dp++, 1, (inf->target + 1) * FONT_Z,
					inf->name[inf->target], 33, FONT_Y );
	DrawSetSymbol( dp++, 1, (i + 1) * FONT_Z,
					inf->name[i], 33 | AttrUnderLine, FONT_Y );
	inf->target= i;

	WindowDraw( wp, dbuf, dp - dbuf );
}


/* L[샋[` */
static int	WinKey( WindowID wp, EventInfo *info, SUBINF *inf )
{
	unsigned int Key= info->KeyCode;
	int	i= inf->target;

	if( Key >= FuncKey && (info->ShiftStat & 2) )
		Key |= 0x200;

	switch( Key ){
	case FuncKeyUp:
	case Ctrl('e'):
	case Ctrl('p'):
		if( --i < 0 ){				/* uv */
			i= inf->max - 1;
		}
		break;

	case FuncKeyDown:
	case Ctrl('n'):
	case Ctrl('x'):
		if ( ++i >= inf->max ) {	/* uv */
			i= 0;
		}
		break;
	default:
		return FALSE;
	}
	cursormove( wp, i, inf );
	return TRUE;
}


static int	SExec( WindowID wp, EventInfo *info )
{
	DrawBuf	dbuf[5 + 8], *dp= dbuf;
	SUBINF	*inf= WindowGetClientPointer( wp );

	switch( info->option ){
	case EventOpen:
		WindowSetEventAttr( wp, EventAttrDefault );
		return	TRUE;

	case EventClose:
		WindowClose( wp );
		return TRUE;

	case EventRedraw:
	{
		int	i, attr;
		int	y= FONT_Z;

		WindowGetViewSize( wp, &i, &y );
		DrawSetClear( dp++, 2 );
		DrawSetLine( dp++, 0, 0, i -1, y - 1, ColorWhite, OptionBox );
		DrawSetLine( dp++, 0, 0, info->h, FONT_Y, ColorWhite, OptionFill );
		DrawSetSymbol( dp++, 1, 1, inf->title, ColorWhite|AttrReverse, FONT_Y );

		y= FONT_Z;
		for( i= 0; i < inf->max; i++ ){
			attr= ( inf->target == i )?(33|AttrUnderLine):33;
			DrawSetSymbol( dp++, 1, y, inf->name[i], attr, FONT_Y );
			y+= FONT_Z;
		}
	}
		WindowDraw( wp, dbuf, dp - dbuf );
		return TRUE;

	case EventMouseSwitch:
		return TRUE;

	case EventKey:
		return WinKey( wp, info, inf );
	}
	return	FALSE;
}


int	select( TBOX *tb )
{
	SUBINF	inf;
	EventInfo	myinfo;
	WindowID	nwp, cwp;
	unsigned char	*param;
	int	len;
	int	x, y, h, v;

	inf.max= 0;
	inf.target= 0;
	cwp= NULL;
	inf.title[0]= NULL;
	h= 0;

	while( *(tb->ptr) != ';' && *(tb->ptr) != 0x1a ){
		param= getparam( tb );
		if( !(*param ) )	break;
		if( *param == '-' ){
			if( *(param + 1) == 't' ){
				strcpy( inf.title, param + 2 );
				len= strlen( param + 2 );
				if( len > h )	h= len;
			}else if( debug ){
				return -5;
			}
		}else {
			strcpy( inf.name[inf.max], param );
			len= strlen( param );
			if( len > h )	h= len;
			inf.label[inf.max]= tb->ptr;
			getparam( tb );
			if( ++inf.max >= 8 )	break;
		}
	}
	skipparam( tb );
	if( !inf.max || h > 40 )	return -5;
	h= h * FONT_X + 2;
	v= (inf.max + 1) * FONT_Z + 2;
	WindowGetScreenPosition( tb->twp, &x, &y );
	x+= (510 - h) / 2;
	if( !tb->y ){
		y+= (510 - v) / 2;
	}else if( tb->y + v <= 510 ){
		y+= tb->y;
	}else {
		y+= 510 - v;
	}
	cwp= WindowSimpleOpen( x, y, h, v, NULL, SExec );

	MS_CURON();
	WindowSetClientData( cwp, 0, &inf );
	WindowRedraw( cwp );
	len= TRUE;

	for(;;){
/*		if( !WindowGetEventInfo( &myinfo ) )	continue;*/
		WindowGetEventInfo( &myinfo );
		nwp= WindowGetChild( WindowRootID, &myinfo );
		if( myinfo.option == EventKey && ( nwp == cwp || nwp == tb->twp ) ){
			if( myinfo.KeyCode == '\r' ){
				break;	/* RET */
			}else {
				WindowSendEvent( cwp, &myinfo );
			}
		}else if( nwp == cwp ){
			if( myinfo.option == EventClose ){
				inf.target= -1;
				break;
			}else if( myinfo.LeftON && len ){
				len= FALSE;
			}else if( myinfo.LeftOFF && !len ){
				if( myinfo.y >= FONT_Z ){
					cursormove( cwp, myinfo.y / FONT_Z - 1, &inf );
					break;
				}
			}else {
				WindowSendEvent( cwp, &myinfo );
			}
		}else if( nwp != tb->twp ){
			WindowSendEvent( nwp, &myinfo );
		}
	}
	WindowClose( cwp );
	if( inf.target < 0 ){
		return FALSE;
	}else {
		tb->ptr= inf.label[inf.target];
		return gotolabel( tb );
	}
}
