*
*	zGRAM-->GRAM]Tu[`
*
* void gput( int mode, unsigned short *vg, ClipClass *clip )
*			mode = 0 : normal
*			       1 : interlace
*			       2 : matrix
*
*			vg   = zGRAM 擪AhX
*
*			clip->x0 = xW
*			clip->y0 = yW
*			clip->x1 = ExW
*			clip->y1 = EyW


	.include	iocscall.mac

	.text

	.even
	.globl	_gput
_gput:
	movem.l	d3-d4/a3-a5,-(sp)
	suba.l	a1,a1
	IOCS	_B_SUPER
	move.l	d0,-(sp)
	movem.l	20+4+8(sp),a0-a1	*vg, clip
	movem.l	(a1),d0-d3		*x0, y0, x1, y1
	lea.l	$C00000,a1		*GRAM

	sub.w	d0,d2
	addq.w	#1,d2			*h
	move.w	d2,d4
	andi.w	#7,d4
	beq	add1
	cmp.w	d0,d4
	bcc	add1
	subq.w	#8,d0
	add.w	d4,d0
add1:
	addq.w	#7,d2
	andi.b	#$f8,d2			*8̔{ɐ؂グ

	sub.w	d1,d3
	addq.w	#1,d3
	move.w	d3,d4
	andi.w	#7,d4
	beq	add2
	cmp.w	d1,d4
	bcc	add2
	subq.w	#8,d1
	add.w	d4,d1
add2:
	addq.w	#7,d3			*v
	andi.b	#$f8,d3			*8̔{ɐ؂グ

	swap.w	d1
	lsr.l	#6,d1			*y0*1024
	add.w	d0,d0
	add.l	d0,d1
	adda.l	d1,a0			*vgtop
	movea.l	a0,a2
	adda.l	d1,a1			*GRAMtop
	movea.l	a1,a3

	move.l	20+4+4(sp),d0		*mode
	subq.w	#1,d0
	beq	interlace
	bpl	matrix

*normal
	move.l	#512,d0
	sub.w	d2,d0
	add.w	d0,d0
	move.w	d2,d1
	and.w	#31,d1
	lsr.w	#5,d2
	swap.w	d2
	move.w	d1,d2
	bra	ylp_ent

ylp:
	move.l	d2,d1
	bra	lineputent

lp1:
	move.w	(a0)+,(a1)+
lineputent:
	dbra	d1,lp1
	swap.w	d1
	bra	blocklp_ent

blocklp:
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+

blocklp_ent:
	dbra	d1,blocklp

	adda.l	d0,a0
	adda.l	d0,a1
ylp_ent:
	dbra	d3,ylp
	bra	rtn


interlace:
	movea.l	a2,a4
	movea.l	a3,a5
	move.l	#2048,d0

	lsr.w	#1,d3
	bcc	even
	movea.l	a2,a0
	movea.l	a3,a1
	move.l	d2,d1
	bsr	ilineputent
	adda.l	d0,a2
	adda.l	d0,a3
even:
	moveq.l	#0,d1
	move.w	d3,d1
	swap.w	d1
	lsr.l	#5,d1
	sub.l	#1024,d1
	adda.l	d1,a4
	adda.l	d1,a5

	bra	iylp_ent

iylp:
	movea.l	a2,a0
	movea.l	a3,a1
	move.l	d2,d1
	bsr	ilineputent		*even
	adda.l	d0,a2
	adda.l	d0,a3

	movea.l	a4,a0
	movea.l	a5,a1
	move.l	d2,d1
	bsr	ilineputent		*odd
	suba.l	d0,a4
	suba.l	d0,a5
iylp_ent:
	dbra	d3,iylp
	bra	rtn

ilp:
	move.w	(a0)+,(a1)+
	nop
	nop
ilineputent:
	dbra	d1,ilp
	rts


matrix:
	movea.l	a2,a4
	movea.l	a3,a5
	move.w	d3,d4			*v
	swap.w	d4
	move.w	d2,d4			*h
	moveq.l	#64,d3

matrix2:
	movea.l	a4,a2
	movea.l	a5,a3

	moveq.l	#64,d1
	sub.w	d3,d1
	subq.w	#1,d3
	swap.w	d3

	lea.l	matrix_tbl(OPC),a0
	moveq.l	#0,d0
	move.b	(a0,d1.l),d0		*yoffset
	move.w	d4,d2			*h
	sub.w	d0,d2
	addq.w	#7,d2
	lsr.w	#3,d2
	swap.w	d0
	lsr.l	#6,d0

	lea.l	64(a0),a0
	move.b	(a0,d1.l),d1		*xoffset
	swap.w	d4
	move.w	d4,d3			*v
	swap.w	d4
	sub.w	d1,d3
	addq.w	#7,d3
	lsr.w	#3,d3
	add.w	d1,d1

	add.l	d0,d1
	adda.l	d1,a2
	adda.l	d1,a3
	move.l	#8192,d0
	bra	m_ylp_ent

m_ylp:
	movea.l	a2,a0
	movea.l	a3,a1
	move.l	d2,d1
	bra	m_lineputent
m_linelp:
	move.w	(a0),(a1)
	lea.l	16(a0),a0
	lea.l	16(a1),a1
m_lineputent:
	dbra	d1,m_linelp
	adda.l	d0,a2
	adda.l	d0,a3
m_ylp_ent:
	dbra	d3,m_ylp
	clr.w	d3
	swap.w	d3
	bne	matrix2

rtn:
	movea.l	(sp)+,a1
	IOCS	_B_SUPER
	movem.l	(sp)+,d3-d4/a3-a5
	rts

	.even

matrix_tbl:
*y
	.dc.b	4,3,3,5,5,4,2,2,2,4,6,6,6,5,3,1
	.dc.b	1,1,1,3,5,7,7,7,7,6,4,2,0,0,0,0
	.dc.b	4,3,4,5,5,3,2,2,3,5,6,6,6,4,2,1
	.dc.b	1,1,2,4,6,7,7,7,7,5,3,1,0,0,0,0
*x
	.dc.b	4,3,5,5,3,2,2,4,6,6,6,4,2,1,1,1
	.dc.b	3,5,7,7,7,7,5,3,1,0,0,0,0,2,4,6
	.dc.b	3,4,5,4,2,2,3,5,6,6,5,3,1,1,1,2
	.dc.b	4,6,7,7,7,6,4,2,0,0,0,0,1,3,5,7

	.even
	.end
